/* Batch Master -- module 1: main() & help routines */
#define MAIN
#include "batm.h"

void main(int argc, char *argv[])
{
	if (argc < 2)
		short_help();					/* Must have a a command 			*/
	if (argc == 2 && (!stricmp(argv[1],"HELP") || argv[1][0] == '?'))
		full_help();
	get_vid_parms();
	if (argc == 2 && file_exists(argv[1]))
		read_file(argv[1]);			/* Commands from file if possible*/
	else
		one_line(argc,argv);			/* else do one line					*/
	exit(exit_val);
}

void short_help()
{
	puts("PC Resource's Batch Master");
	puts("Type BATM HELP for help");
	exit(0);
}

void full_help()
{
	puts("              PC Resource's Batch Master");
	puts("");
	puts("Supported functions:");
	puts("--------------------");
	puts("");
	puts("Take input from file:");
	puts("   BATM filename");

	puts("");
	puts("Print on screen with optional colors:");
	puts("   BATM SAY \"text\" [fg bg]");
	puts("   BATM SAY@ col row \"text\" [fg bg]");
	
	puts("");
	puts("Prompt and get errorlevel response with optional colors:");
	puts("   BATM ASK \"prompt\" \"answers\" [fg bg]");
	puts("   BATM ASK@ col row \"prompt\" \"answers\" [fg bg]");

	puts("");
	puts("Other screen functions:");
	puts("   BATM SKPLINE [count]                    move down one line or more");
	puts("   BATM CLS [fg bg]                        clear the screen");
	puts("   BATM COLOR fg bg                        set new colors");
	puts("   BATM BOX top left bottom right [fg bg]  draw a box");
	puts("   BATM REPTCHAR char n [fg bg]            displays char n times");
	puts("");
	puts("");
	fputs("Press a key...",stdout);
	getch();
	puts("");
	puts("Time functions:");
	puts("   BATM WAIT hh:mm                         waits until given time");
	puts("   BATM DELAY n                            waits for n seconds");
	puts("");
	puts("Printer functions:");
	puts("   BATM TYPE LF [count]                    types 1 or more linefeeds");
	puts("   BATM TYPE FF [count]                    types 1 or more formfeeds");
	puts("   BATM TYPE \"text\"                        types text on printer");
	puts("   BATM TYPECHAR n [n ...]                 types 1 or more ASCII values");
	puts("");
	puts("Environment variable functions:");
	puts("   BATM INC var                            adds 1 to var");
	puts("   BATM DEC var                            subtracts 1 from var");
	puts("");
	puts("   BATM BEEP f d                           makes a tone of frequency f");
	puts("                                          lasting for d tenths of a second");
	exit(0);
}



