/* Batch Master -- module 2: file input routines */
#include "batm.h"

int file_exists(char *s)		/* Does s ==> valid file name? */
{
	struct stat buf;
	if (! stat(s,&buf) && buf.st_size > 0)
		return TRUE;
	else
		return FALSE;
}

void read_file(char *fn)		/* Read and execute each line of file */
{
	FILE *fp;
	char buf[81];

	if ((fp = fopen(fn,"r")) == NULL) {
		printf("File %s not found.",fn);
		short_help();				/* Help if can't open the file			*/
		}
	do {
		fgets(buf,80,fp);
		parse_line(buf);
		} while (!feof(fp));
	fclose(fp);
}

void parse_line(char *s)		/* Parse and execute 1 line of file */
{
	int argc, i;
	char *argv[50], *temp;

	while (strlen(s) && iscntrl(s[strlen(s)-1]))
		s[strlen(s)-1] = '\0';	/* Remove trailing CR/LF				*/
	while (isspace(s[strlen(s)-1]))
		s[strlen(s)-1] = '\0';	/* Remove trailing spaces				*/
	while (isspace(*s))
		s++;							/* Remove leading spaces				*/
	if (*s == '#' || !strlen(s))
		return;						/* Skip comments & blank lines		*/
	argc = 1;
	argv[0] = NULL;
	if ((temp = get_arg(s)) != NULL) { /* Get and store arguments	*/
		argv[argc++] = strdup(temp);
		while((temp = get_arg(NULL)) != NULL && argc < 50)
			argv[argc++] = strdup(temp);
		}
	if (argc > 1) {				/* Execute the line						*/
		one_line(argc,argv);
		for(i = 1; i < argc; i++)
			free(argv[i]);			/* Free argument space					*/
		}
}

char *get_arg(char *s)
{
	static char *arg = NULL, *start;
	char *temp, qchar;

	if (s != NULL) {				/* If new line, save it					*/
		arg = strdup(s);
		start = arg;
		}
	else if (arg == NULL)
		return NULL;				/* If done with line, return NULL	*/
	if (*arg == '\0') {
		free(start);
		arg = NULL;
		return NULL;
		}
	while (isspace(*arg))		/* Skip leading spaces					*/
		arg++;
	temp = arg++; 					/* Save start & move to next char	*/
	qchar = *temp;					/* If we start with a quote mark:	*/
	if (qchar == '\'' || qchar == '\"') {
		temp++;						/* Don't return the quote 				*/
		while (*arg != qchar && *arg != '\0')
			arg++;					/* Go to end of line or next quote	*/
		}
	else	
		while (*arg != '\0' && !isspace(*arg))
			arg++;					/* Else look for next space or EOL	*/
	if (*arg != '\0')				
			*arg++ = '\0';			/* Terminate arg & keep posn of next*/
	return temp;
}

