/* Batch Master -- module 5: Say, Ask, Cls, & Color */
#include "batm.h"

void say(int argc, char *argv[])			/* Print message on screen */
{
	if (argc == 5)
		set_color(atoi(argv[3]), atoi(argv[4]));
	if (argc >= 3)
		show_line(argv[2], TRUE);
}

void say_at(int argc, char *argv[])		/* Print message at location */
{
	if (argc == 7)
		set_color(atoi(argv[5]),atoi(argv[6]));
	if (argc >= 5) {
		set_cursor(atoi(argv[3])-1, atoi(argv[2])-1);
		show_line(argv[4], TRUE);
		}
}

void ask(int argc, char *argv[])			/* Prompt user						*/
{
	int ch;
	if (argc == 6)
		set_color(atoi(argv[4]),atoi(argv[5]));
	if (argc >= 4) {
		show_line(argv[2],FALSE);
		strupr(argv[3]);
		do	{
			ch = getch();
			ch = toupper(ch);
			} while (strchr(argv[3],ch) == NULL);
		exit_val = strchr(argv[3],ch) - argv[3] + 1;
		show_char(ch);
		show_char('\n');
		}
}

void ask_at(int argc, char *argv[])		/* Prompt at a screen location */
{
	int ch;
	if (argc == 8)
		set_color(atoi(argv[6]), atoi(argv[7]));
	if (argc >= 6) {
		set_cursor(atoi(argv[3])-1, atoi(argv[2])-1);
		show_line(argv[4], FALSE);
		strupr(argv[5]);
		do {
			ch = getch();
			ch = toupper(ch);
			} while (strchr(argv[5],ch) == NULL);
		exit_val = strchr(argv[5],ch) - argv[5] + 1;
		show_char(ch);
		show_char('\n');
		}
}

void cls(int argc, char *argv[])				/* Clear the screen			*/
{
	if (argc == 4)
		set_color(atoi(argv[2]), atoi(argv[3]));
#ifdef ANSI
	fputs("\x1b[2J",stdout);
#else
	ireg.x.ax = 0x0600;
	ireg.h.bh = (char) vid_attr;
	ireg.x.cx = 0;
	ireg.h.dh = (char) vid_rows - 1;
	ireg.h.dl = (char) vid_cols - 1;
	int86(0x10, &ireg, &oreg);
	set_cursor(0,0);
#endif
}

void color(int argc, char *argv[])			/* Set a new color			*/
{
	if (argc == 4)
		set_color(atoi(argv[2]), atoi(argv[3]));
}
