/* Batch Master -- module 6: Type, Wait, Delay, & Beep */

#include "batm.h"

void type(int argc, char *argv[])		/* Type on the printer		*/
{
	int i, count;
	if (argc < 3)
		return;
	if (argc == 4)
		count = atoi(argv[3]);
	else
		count = 1;
	if (!strcmp(argv[2], "LF"))			/* If a LF (linefeed)		*/
		for (i = 0; i < count; i++)
			fputs("\n\r",stdprn);
	else if (!strcmp(argv[2], "FF"))		/* If a FF (formfeed)		*/
		for (i = 0; i < count; i++)
			fputs("\x0c",stdprn);
	else {
		fputs(argv[2],stdprn);
		fputs("\n\r",stdprn);
		}
	fflush(stdprn);
}

void typechar(int argc, char *argv[])	/* Send ASCII/Control characters */
{													/* to the printer						*/
	int i;
	for (i = 2; i < argc; i++)
		fputc(atoi(argv[i]),stdprn);
	fflush(stdprn);
}

void dlay(int argc, char *argv[])		/* Delay for n seconds				*/
{
	if (argc == 3)
		ms_delay(atol(argv[2]) * CLK_TCK);
}

void wait(int argc, char *argv[])		/* Wait until specified time		*/
{
	if (argc == 3)
		wait_time(argv[2]);
}

void beep(int argc, char *argv[])		/* Beep at freq. for n * 0.1 sec. */
{
	if (argc == 4)
		make_beep(atoi(argv[2]), atoi(argv[3]));
}
