/* Batch Master -- module 8: Inc & Dec */

/* If you use Quick C 2.0, turn off pointer checks when you compile
 * this module.
 */

#include "batm.h"

static int limit, delta;
static char *varname;
static unsigned envseg, varoff;
static char value[6];

static void change_var(void);
static int find_parent_env(void);
static int test_env(unsigned eseg);
static int find_env_var(void);

void inc(int argc, char *argv[])				/* Add 1 to value				*/
{
	if (argc == 3) {
		limit = 32767;
		delta = 1;
		varname = strdup(strupr(argv[2]));
		if (varname != NULL)
			change_var();
		}
}

void dec(int argc, char *argv[])				/* Subtract 1 from value	*/
{
	if (argc == 3)	{
		limit = 0;
		delta = -1;
		varname = strdup(strupr(argv[2]));
		if (varname != NULL)
			change_var();
		}
}

void change_var()									/* Change a value				*/
{
	char far *ep, temp_val[7];
	int i, val;

	if (!find_parent_env() || !find_env_var()) {
		exit_val = 1;
		return;
		}
	FP_SEG(ep) = envseg;
	FP_OFF(ep) = varoff;
	i = 0;
	while (*ep && i < 5 && isdigit(*ep))			/* Read current value	*/
		value[i++] = *ep++;
	if (*ep == '\0')
		value[i] = '\0';
	else {
		exit_val = 1;
		return;
		}
	val = atoi(value) + delta;							/* Make new value			*/
	if ((delta > 0 && val <= limit) || (delta < 0 && val >= limit)) {
		itoa(val,temp_val,10);
		if (strlen(temp_val) <= strlen(value)) {
			sprintf(temp_val,"%0*d",strlen(value),val);
			FP_OFF(ep) = varoff;
			i = 0;
			while(temp_val[i])
				*ep++ = temp_val[i++];
			return;
			}
		}
	exit_val = 1;											/* Here if we fail		*/
}


#pragma pack (1)

int find_parent_env()									/* Find active environ.	*/
{
	unsigned far *fp;
	unsigned cmd_seg;
	struct SREGS sreg;
	struct MEMBLK {
		char		type;
		unsigned owner;
		unsigned size;
		} far *mb;

	envseg = 0;
	FP_SEG(fp) = _psp;
	FP_OFF(fp) = 0x16;
	do { FP_SEG(fp) = *fp;
		} while (*fp != FP_SEG(fp) && *fp != 0);
	cmd_seg = FP_SEG(fp);
	ireg.h.ah = 0x52;
	intdosx(&ireg, &oreg, &sreg);
	FP_SEG(fp) = sreg.es;
	FP_OFF(fp) = oreg.x.bx - 2;
	FP_SEG(mb) = *fp;
	FP_OFF(mb) = 0;
	do {
		if (mb->owner == cmd_seg && test_env(FP_SEG(mb)+1))
			envseg = FP_SEG(mb) + 1;
		FP_SEG(mb) += mb->size + 1;
		} while (mb->type != 'Z');
	return envseg;
}

int test_env(unsigned eseg)					/* Verify we have an environ. */
{
	char far *cp;
	int count, i;

	FP_SEG(cp) = eseg;
	FP_OFF(cp) = 0;
	for (i = 0, count = 0; i < 128 && cp[i] != '='; i++)
		if (isupper(cp[i]) || ispunct(cp[i]) || isdigit(cp[i]))
			count++;
		else
			return 0;
	return count;
}

int find_env_var()								/* Find variable in environ.*/
{
	char far *envp;
	char *var;
	FP_SEG(envp) = envseg;
	FP_OFF(envp) = 0;
	while (*envp != '\0') {
		var = varname;
		while (*var == *envp && *var != '\0') {
			var++;
			envp++;
			}
		if (*var == 0 && *envp++ == '=') {
			varoff = FP_OFF(envp);
			return 1;
			}
		else
			while (*envp++ != '\0')
				;
		}
	return 0;
}
