* ==================== System Login Routine =====================

PROCEDURE login

* ----- set screen to white on white and ask for user_id -----
CLEAR
@8, 28 SAY "Enter User ID:"
* ----- blank out text typed in variable area -----
SET COLOR TO W/B,X/W
* ------
SET DELIMITERS ON
@ROW(), COL()+2 GET mv_user_id PICTURE "@! NNNNNN"
SET DELIMITERS OFF
* --
READ
* ----- unhide and open user id file -----
SET COLOR TO W*/B,X/W
@12, 25 SAY "****** Checking User ID ******"
SET CONSOLE OFF
RUN FA user_ids.dbf /hid-/r- > nul
USE user_ids
* --- check user id against authorized list ---
LOCATE FOR password = mv_user_id
mv_inits = initials
* ----- rehide user id file -----
USE
RUN FA user_ids.dbf /hid+/r+ > nul
SET CONSOLE ON
* --- restore screen to default colors -----
SET COLOR TO
* ----- if not found return to dbase -----
IF mv_inits = SPACE(3)
   ?? CHR(7)
   CLEAR
   @10,      22 SAY "   Sorry, User ID not Found ...."
   @ROW()+2, 22 SAY "(Press Any Key to Return to dBase)"
   * ----- loop and wait for a keystroke -----
   mv_key = 0
   DO WHILE mv_key = 0
      mv_key = INKEY()
   ENDDO
   * --
   RETURN
ENDIF
* ----- record start date/time in system log -----
USE main_log
APPEND BLANK
* ----- stamp record with check in information ----
DO check_in
* ----- transfer control to main menu loop -----
DO mainmenu
* ----- stamp record with check out information ---
USE main_log
DO checkout
* ----- calculate elapsed time -----
DO timecalc
* ----
RETURN

* ============= Menu Routine for Sales Functions ================

PROCEDURE mainmenu

DO WHILE .T.
   * -----
   CLEAR
   @4,0
   mv_choice = 0
   TEXT
                        Sales Contacts Database System -

                       1.  Add Sales Contact Records

                       2.  Print Out List of Contacts

                       3.  Exit to Dot Prompt
   ENDTEXT
   @ROW()+2, 24     SAY "Make choice by number ===>" 
   @ROW(), COL()+2  GET mv_choice PICTURE "@Z 9"
   * --
   READ
   * -----
   DO CASE
      CASE mv_choice = 1
         DO add_recs
      CASE mv_choice = 2
         DO prntrecs
      CASE mv_choice = 3
         EXIT
      OTHERWISE
         ?? CHR(7)
         LOOP
   ENDCASE 
   * -----
ENDDO
* ---
RETURN

* ================= Routine to Add Records ======================

PROCEDURE add_recs

* ----- record start date time and procedure description -----
USE proc_log
APPEND BLANK
REPLACE routine WITH "Record Entry Routine"
* ----- stamp record with check in information ----
DO check_in
* ----- enter record entry routine -----
DO WHILE .T.
   * -----
   CLEAR
   USE contacts
   APPEND BLANK
   REPLACE initials WITH mv_inits
   REPLACE date WITH DATE()
   @6,       23      SAY "Product Inquiry Entry Screen"
   @ROW()+2, 15      SAY "Customer Name (fn/ln):   " 
   @ROW(),   COL()+2 GET cust_fn
   @ROW(),   COL()+2 GET cust_ln
   @ROW()+2, 15      SAY "Customer's Phone:        " 
   @ROW(), COL()+2   GET phone PICTURE "(999) 999-9999"
   @ROW()+2, 15      SAY "Product Code:            " 
   @ROW(), COL()+2   GET product PICTURE "999"
   @ROW()+2, 15      SAY "Salesperson Requested:   " 
   @ROW(), COL()+2   GET salesper PICTURE "@! AAA"
   @ROW()+2, 15      SAY "Taken by:  " 
   @ROW(),   COL()+2 SAY initials
   @ROW(),   COL()+3 SAY "Date:  " GET date
   * ----- add to/edit the information -----
   READ
   * ----- close database and offer continuation choice -----
   USE
   CLEAR
   mv_cont = "Y"
   @10, 27 SAY "Enter Another (Y/N)?:  " GET mv_cont PICTURE "Y"
   * --
   READ
   * --
   IF mv_cont = "N"
      EXIT
   ENDIF
   * ---
ENDDO
* ----- record stop date and time in system log -----
USE proc_log
DO checkout
* ----- calculate elapsed time -----
DO timecalc
* ----
RETURN

* =============== Routine to Print Records ======================

PROCEDURE prntrecs

* ----- record start date and time and procedure description -----
USE proc_log
APPEND BLANK
REPLACE routine WITH "Print-Out Routine"
* ----- stamp record with check in information ----
DO check_in
* ----- enter print routine -----
USE contacts
SET PRINT ON
* -----
DO WHILE .NOT. EOF()
   ?  SPACE(10) + cust_fn + " " + cust_ln + " " + phone
   ?? "  " + product
   ?? "  " + salesper + "  " + initials + DTOC(date)
   SKIP
ENDDO
* --- clean up -----
USE
SET PRINT OFF
EJECT
* ----- record stop date and time in system log -----
USE proc_log
DO checkout
* ----- calculate elapsed time -----
DO timecalc
* ----
RETURN

* =============== Subroutine to Do Login Stamp =================

PROCEDURE check_in

* -----
REPLACE initials WITH mv_inits
REPLACE begday   WITH SUBSTR(CDOW(DATE()),1,3)
REPLACE begdate  WITH DATE()
REPLACE begtime  WITH TIME()
USE
* ----
RETURN

* ============== Subroutine to Do Logout Stamp ==================

PROCEDURE checkout

* -----
GO BOTTOM
REPLACE endday  WITH SUBSTR(CDOW(DATE()),1,3)
REPLACE enddate WITH DATE()
REPLACE endtime WITH TIME()
* ----
RETURN

* ======== Subroutine to Do Time Calculations ===================

PROCEDURE timecalc

* ----- initialize time variables -----
mv_etime = 0
mv_date1 = begdate
mv_time1 = begtime
mv_date2 = enddate
mv_time2 = endtime
* ----- check to see if date has rolled over -----
mv_dd =  mv_date2-mv_date1
* ----- absolute start time greater than absolute stop time -----
IF mv_time1 > mv_time2
   STORE mv_dd-1 TO mv_dd
ENDIF
* ----- get count of total seconds for start and stop break-points -----
mv_hh1 = VAL(SUBSTR(mv_time1,1,2))*3600
mv_mm1 = VAL(SUBSTR(mv_time1,4,2))*  60
mv_ss1 = VAL(SUBSTR(mv_time1,7,2))*   1
mv_hh2 = VAL(SUBSTR(mv_time2,1,2))*3600
mv_mm2 = VAL(SUBSTR(mv_time2,4,2))*  60
mv_ss2 = VAL(SUBSTR(mv_time2,7,2))*   1
mv_point1 = mv_hh1+mv_mm1+mv_ss1
mv_point2 = mv_hh2+mv_mm2+mv_ss2
* ----- calculate total second count excluding whole days -----
DO CASE
   * ----- stop and start on same day -----
   CASE mv_time2 > mv_time1
       mv_etime = mv_point2-mv_point1
   * ----- date rollover so reciprocal adjustment necessary -----
   CASE mv_time1 > mv_time2
       mv_point1 = (3600*24)-mv_point1
       mv_etime = mv_point1+mv_point2
ENDCASE
* ----- calculate hours minutes and seconds in remainder -----
mv_hh    = INT(mv_etime/3600)
mv_etime = mv_etime-(3600*mv_hh)
mv_mm    = INT(mv_etime/60)
mv_etime = mv_etime-(60*mv_mm)
mv_ss    = mv_etime
* ----- log elapsed time count to file -----
REPLACE dd WITH mv_dd
REPLACE hh WITH mv_hh
REPLACE mm WITH mv_mm
REPLACE ss WITH mv_ss
* -----
RETURN

* ========================= End of Code =========================
